diff --git a/ospf6d/ospf6_message.c b/ospf6d/ospf6_message.c
index ac0beeaf6bfd..da1a57533c8b 100644
--- a/ospf6d/ospf6_message.c
+++ b/ospf6d/ospf6_message.c
@@ -2529,7 +2529,8 @@ void ospf6_lsreq_send(struct thread *thread)
 
 	/* schedule loading_done if request list is empty */
 	if (on->request_list->count == 0) {
-		thread_add_event(master, loading_done, on, 0, NULL);
+		thread_add_event(master, loading_done, on, 0,
+				 &on->event_loading_done);
 		return;
 	}
 
diff --git a/ospf6d/ospf6_neighbor.c b/ospf6d/ospf6_neighbor.c
index 4dbfce836e90..b4911ad6f00f 100644
--- a/ospf6d/ospf6_neighbor.c
+++ b/ospf6d/ospf6_neighbor.c
@@ -178,6 +178,7 @@ void ospf6_neighbor_delete(struct ospf6_neighbor *on)
 	THREAD_OFF(on->thread_send_lsack);
 	THREAD_OFF(on->thread_exchange_done);
 	THREAD_OFF(on->thread_adj_ok);
+	THREAD_OFF(on->event_loading_done);
 
 	THREAD_OFF(on->gr_helper_info.t_grace_timer);
 
@@ -438,7 +439,8 @@ void ospf6_check_nbr_loading(struct ospf6_neighbor *on)
 	if ((on->state == OSPF6_NEIGHBOR_LOADING)
 	    || (on->state == OSPF6_NEIGHBOR_EXCHANGE)) {
 		if (on->request_list->count == 0)
-			thread_add_event(master, loading_done, on, 0, NULL);
+			thread_add_event(master, loading_done, on, 0,
+					 &on->event_loading_done);
 		else if (on->last_ls_req == NULL) {
 			THREAD_OFF(on->thread_send_lsreq);
 			thread_add_event(master, ospf6_lsreq_send, on, 0,
diff --git a/ospf6d/ospf6_neighbor.h b/ospf6d/ospf6_neighbor.h
index ea4d4241528f..1f275af68e36 100644
--- a/ospf6d/ospf6_neighbor.h
+++ b/ospf6d/ospf6_neighbor.h
@@ -138,6 +138,7 @@ struct ospf6_neighbor {
 	struct thread *thread_send_lsack;
 	struct thread *thread_exchange_done;
 	struct thread *thread_adj_ok;
+	struct thread *event_loading_done;
 
 	/* BFD information */
 	struct bfd_session_params *bfd_session;
